/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import {exists, mapValues} from '../runtime';
import {
  Pageable,
  PageableFromJSON,
  PageableFromJSONTyped,
  PageableToJSON,
} from './Pageable';
import {Sort, SortFromJSON, SortFromJSONTyped, SortToJSON} from './Sort';
import {
  TransactionMessage,
  TransactionMessageFromJSON,
  TransactionMessageFromJSONTyped,
  TransactionMessageToJSON,
} from './TransactionMessage';

/**
 *
 * @export
 * @interface PageTransactionMessage
 */
export interface PageTransactionMessage {
  /**
   *
   * @type {number}
   * @memberof PageTransactionMessage
   */
  totalPages?: number;
  /**
   *
   * @type {number}
   * @memberof PageTransactionMessage
   */
  totalElements?: number;
  /**
   *
   * @type {number}
   * @memberof PageTransactionMessage
   */
  size?: number;
  /**
   *
   * @type {Array<TransactionMessage>}
   * @memberof PageTransactionMessage
   */
  content?: Array<TransactionMessage>;
  /**
   *
   * @type {number}
   * @memberof PageTransactionMessage
   */
  number?: number;
  /**
   *
   * @type {Sort}
   * @memberof PageTransactionMessage
   */
  sort?: Sort;
  /**
   *
   * @type {number}
   * @memberof PageTransactionMessage
   */
  numberOfElements?: number;
  /**
   *
   * @type {Pageable}
   * @memberof PageTransactionMessage
   */
  pageable?: Pageable;
  /**
   *
   * @type {boolean}
   * @memberof PageTransactionMessage
   */
  first?: boolean;
  /**
   *
   * @type {boolean}
   * @memberof PageTransactionMessage
   */
  last?: boolean;
  /**
   *
   * @type {boolean}
   * @memberof PageTransactionMessage
   */
  empty?: boolean;
}

export function PageTransactionMessageFromJSON(
  json: any
): PageTransactionMessage {
  return PageTransactionMessageFromJSONTyped(json, false);
}

export function PageTransactionMessageFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): PageTransactionMessage {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    totalPages: !exists(json, 'totalPages') ? undefined : json['totalPages'],
    totalElements: !exists(json, 'totalElements')
      ? undefined
      : json['totalElements'],
    size: !exists(json, 'size') ? undefined : json['size'],
    content: !exists(json, 'content')
      ? undefined
      : (json['content'] as Array<any>).map(TransactionMessageFromJSON),
    number: !exists(json, 'number') ? undefined : json['number'],
    sort: !exists(json, 'sort') ? undefined : SortFromJSON(json['sort']),
    numberOfElements: !exists(json, 'numberOfElements')
      ? undefined
      : json['numberOfElements'],
    pageable: !exists(json, 'pageable')
      ? undefined
      : PageableFromJSON(json['pageable']),
    first: !exists(json, 'first') ? undefined : json['first'],
    last: !exists(json, 'last') ? undefined : json['last'],
    empty: !exists(json, 'empty') ? undefined : json['empty'],
  };
}

export function PageTransactionMessageToJSON(
  value?: PageTransactionMessage | null
): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    totalPages: value.totalPages,
    totalElements: value.totalElements,
    size: value.size,
    content:
      value.content === undefined
        ? undefined
        : (value.content as Array<any>).map(TransactionMessageToJSON),
    number: value.number,
    sort: SortToJSON(value.sort),
    numberOfElements: value.numberOfElements,
    pageable: PageableToJSON(value.pageable),
    first: value.first,
    last: value.last,
    empty: value.empty,
  };
}
